use Getopt::Std;
use List::Util qw(min max);
getopts('i:o:t:m:s:');

$input=$opt_i;
$output=$opt_o;
$thresh=$opt_t;
$method=$opt_m;
$scanlength=$opt_s;

if($opt_i eq '')
{
    print "USAGE: clbtope.pl -i <fasta format sequences> -o <output file name> -t <threshold> -m <method> -s <scanning length>\n\n";
    print "Example Command: ./clbtope.pl -i /gpsr/examples/example_clbtope.fasta -o out -t 0.53 -m 1 -s 9\n\n";
    print "-i\tSequence in FASTA format\n";
    print "-o\toutput file\n";
    print "-t\tthreshold\n";
    print "-m\tMethods:\n\tChoose methods from following options, and provide option as 1,2 or 3: \n\t1 for Prediction\n\t2 for Design\n\t3 for Scan\n\tBy Default its 1\n";
    print "-s\tLength of the overlapping patterns to be generated from the submitted sequences\n";
    exit();
}
$prog_path="prog";
$ran=int(rand(10000));
$dir="temp/clbtope$ran";
`mkdir "$dir"`;
if($method==1 or $method==""){
     $scanlength = 9;
    `python3 $prog_path/read_fasta.py $input $dir/input_user_1`;
    `grep -v '>' $dir/input_user_1 >$dir/input_sline`;
    `grep '>' $dir/input_user_1 >$dir/header`;
    `perl -pi -e 's/\r$//g' $dir/input_sline`;
     my $xx = '/input_sline';
     my $filename = $dir.$xx;
     open(FH, '<', $filename) or die $!;
     my @newlist = ();
    print @newlist;
    while(<FH>)
        {
        push(@newlist, length($_)) ;
        }
    if(min(@newlist)<8)
        {
        print "\n\nError: Some of the submitted seqeunce(s) have length less than 8, please provide sequences with length greater than or equal to 8.\n\n";
        exit();
        }
    if(min(@newlist)>30)
        {
        print "\n\nError: Some of the submitted seqeunce(s) have length greater than 30, please provide sequences with length between 8 and 30.\n\n";
        exit();
        }
        close(FH);
    `python3 $prog_path/clbtope.py -i $input -o $output -t $thresh -j $method -w $scanlength`;
}
if($method==2){
    if($scanlength=="")
     {
     print "\n\nError: Please provide the length of the pattern to scan over the seqeunces.\n\n";
     exit();
     }
     if($scanlength<8 or $scanlength>30)
     {
     print "\n\nError: Please provide the pattern length between 8 and 30.\n\n";
     exit();
     }
    `python3 $prog_path/read_fasta.py $input $dir/input_user_1`;
    `grep -v '>' $dir/input_user_1 >$dir/input_sline`;
    `grep '>' $dir/input_user_1 >$dir/header`;
     my $xx = '/input_sline';
     my $filename = $dir.$xx;
     open(FH, '<', $filename) or die $!;
     my @newlist = ();
    while(<FH>)
        {
        push(@newlist, length($_)) ;
        }
    if(min(@newlist)<8)
        {
        print "\n\nError: Some of the submitted seqeunce(s) have length less than 8, please provide sequences with length greater than or equal to 8.\n\n";
        exit();
        }
    if($scanlength<8 or $scanlength>30)
        {
        print "\n\nError: Please provide the pattern length between 8 and 30.\n\n";
        exit();
        }
    if(min(@newlist)<$scanlength)
        {
        print "\n\nThe minimum length of the provided seqeuence(s) is ",min(@newlist);
        print "\n";
        print "The length of the given pattern is ",$scanlength;
        print "\n";
        print "The pattern length should be less than the sequence length, which is not true here.\nPlease provide the pattern length between ",min(@newlist)," and 30.";
        print "\n";
        exit();
        }
       close(FH);
    `python3 $prog_path/clbtope.py -i $input -o $output -t $thresh -j $method -w $scanlength`;
}
if($method==3){
    $scanlength = 9;
    `python3 $prog_path/read_fasta.py $input $dir/input_user_1`;
    `grep -v '>' $dir/input_user_1 > $dir/input_sline`;
    `grep '>' $dir/input_user_1 >$dir/header`;
     my $xx = '/input_sline';
     my $filename = $dir.$xx;
     open(FH, '<', $filename) or die $!;
     my @newlist = ();
    while(<FH>)
        {
        push(@newlist, length($_)) ;
        }
    if(min(@newlist)<8)
        {
        print "\n\nError: Some of the submitted seqeunce(s) have length less than 8, please provide sequences with length greater than or equal to 8.\n\n";
        exit();
        }
    if(min(@newlist)>30)
        {
        print "\n\nError: Some of the submitted seqeunce(s) have length greater than 8, please provide sequences with length between 8 and 30.\n\n";
        exit();
        }
        close(FH);
    `python3 $prog_path/clbtope.py -i $input -o $output -t $thresh -j $method -w $scanlength`;
}
